Skip to content

Color picker

This tutorial shows you how to integrate the Pickr color picker library as a custom Handsontable cell editor, with a swatch renderer and hex validation.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
import Pickr from '@simonwep/pickr';
import '@simonwep/pickr/dist/themes/nano.min.css';
// Register all Handsontable's modules.
registerAllModules();
186 collapsed lines
/* start:skip-in-preview */
const inputData = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
{
id: 954632,
itemName: 'Oxygen Unit',
itemNo: 'FK-87',
leadEngineer: 'Dr. Grace Augustine',
cost: 600000,
inStock: true,
category: 'Life Support',
itemQuality: 85,
origin: '🇺🇸 USA',
quantity: 15,
valueStock: 9000000,
repairable: true,
supplierName: 'OxyGenius',
restockDate: '2026-03-02',
operationalStatus: 'Awaiting Parts',
},
{
id: 734944,
itemName: 'Processing Rig',
itemNo: 'LK-13',
leadEngineer: 'Jake Sully',
cost: 350000,
inStock: true,
category: 'Mining',
itemQuality: 81,
origin: '🇦🇺 Australia',
quantity: 25,
valueStock: 8750000,
repairable: true,
supplierName: 'RigTech',
restockDate: '2026-04-15',
operationalStatus: 'Ready for Testing',
},
{
id: 834662,
itemName: 'Navigation Module',
itemNo: 'XP-24',
leadEngineer: 'Dr. Ellie Arroway',
cost: 450000,
inStock: true,
category: 'Navigation',
itemQuality: 89,
origin: '🇫🇷 France',
quantity: 8,
valueStock: 3600000,
repairable: false,
supplierName: 'NavSolutions',
restockDate: '2026-05-30',
operationalStatus: 'In Maintenance',
},
{
id: 714329,
itemName: 'Surveyor Arm',
itemNo: 'QA-86',
leadEngineer: 'Mark Watney',
cost: 100000,
inStock: true,
category: 'Exploration',
itemQuality: 78,
origin: '🇺🇸 USA',
quantity: 40,
valueStock: 4000000,
repairable: true,
supplierName: 'ExploreTech',
restockDate: '2026-07-12',
operationalStatus: 'Decommissioned',
},
];
const data = inputData.map((el) => ({
...el,
// eslint-disable-next-line no-mixed-operators
color: `#${
// eslint-disable-next-line no-mixed-operators
Math.round(0x1000000 + 0xffffff * Math.random())
.toString(16)
.slice(1)
.toUpperCase()
}`,
}));
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1');
const cellDefinition = {
renderer: rendererFactory(({ td, value }) => {
td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
}),
validator: (value, callback) => {
callback(value.length === 7 && value[0] == '#'); // validate color format
},
editor: editorFactory({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT');
editor.input.setAttribute('aria-label', 'Open color picker');
editor.input.classList.add('color-picker-editor');
},
afterInit(editor) {
const button = editor.hot.rootDocument.createElement('button');
button.textContent = 'Open color picker';
button.classList.add('color-picker-button');
editor.input.after(button);
editor.pickr = Pickr.create({
el: button,
theme: 'nano',
default: editor.input.value || '#000000',
autoReposition: false,
padding: 0,
components: {
preview: true,
hue: true,
}
});
// Collapse the Pickr trigger button so it doesn't add vertical space
// between the cell editor and the popup.
editor.pickr._root.root.style.height = '0';
editor.pickr._root.root.style.overflow = 'hidden';
editor.preventCloseElement = editor.pickr._root.app;
editor.pickr.on('change', (color) => {
if (color) {
const hex = color.toHEXA().toString();
editor.input.value = hex;
}
});
editor.pickr.on('hide', () => {
if (Date.now() - editor._openedAt < 400) {
editor.pickr.show();
return;
}
editor.finishEditing();
});
},
afterOpen(editor) {
editor._openedAt = Date.now();
editor.pickr.setColor(editor.input.value || '#000000');
editor.pickr.show();
// Pickr positions its popup relative to the trigger button with an
// internal offset. Override the top to sit flush below the cell.
// Use double-rAF to ensure Pickr's own positioning is complete.
requestAnimationFrame(() => {
requestAnimationFrame(() => {
const cellRect = editor.TD.getBoundingClientRect();
editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
});
});
},
afterClose(editor) {
editor.pickr._root.app.classList.remove('visible');
editor.pickr.hide();
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
},
shortcuts: [
{
keys: [['Tab']],
callback: (editor) => {
editor.pickr.hide();
},
},
],
}),
};
// Define configuration options for the Handsontable
const hotOptions = {
data,
colHeaders: ['ID', 'Item Name', 'Item Color', 'Item No.', 'Cost', 'Value in Stock'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
columns: [
{
data: 'id',
type: 'numeric',
width: 80,
headerClassName: 'htLeft',
},
{
data: 'itemName',
type: 'text',
width: 200,
headerClassName: 'htLeft',
},
{
data: 'color',
headerClassName: 'htLeft',
...cellDefinition,
},
{
data: 'itemNo',
type: 'text',
width: 100,
headerClassName: 'htLeft',
},
{
data: 'cost',
type: 'numeric',
width: 70,
headerClassName: 'htLeft',
},
{
data: 'valueStock',
type: 'numeric',
width: 130,
headerClassName: 'htRight',
},
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { editorFactory } from 'handsontable/editors';
import { rendererFactory } from 'handsontable/renderers';
import Pickr from '@simonwep/pickr';
import '@simonwep/pickr/dist/themes/nano.min.css';
import { CellProperties } from 'handsontable/settings';
// Register all Handsontable's modules.
registerAllModules();
188 collapsed lines
/* start:skip-in-preview */
const inputData = [
{
id: 640329,
itemName: 'Lunar Core',
itemNo: 'XJ-12',
leadEngineer: 'Ellen Ripley',
cost: 350000,
inStock: true,
category: 'Lander',
itemQuality: 87,
origin: '🇺🇸 USA',
quantity: 2,
valueStock: 700000,
repairable: false,
supplierName: 'TechNova',
restockDate: '2025-08-01',
operationalStatus: 'Awaiting Parts',
},
{
id: 863104,
itemName: 'Zero Thrusters',
itemNo: 'QL-54',
leadEngineer: 'Sam Bell',
cost: 450000,
inStock: false,
category: 'Propulsion',
itemQuality: 0,
origin: '🇩🇪 Germany',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'PropelMax',
restockDate: '2025-09-15',
operationalStatus: 'In Maintenance',
},
{
id: 395603,
itemName: 'EVA Suits',
itemNo: 'PM-67',
leadEngineer: 'Alex Rogan',
cost: 150000,
inStock: true,
category: 'Equipment',
itemQuality: 79,
origin: '🇮🇹 Italy',
quantity: 50,
valueStock: 7500000,
repairable: true,
supplierName: 'SuitCraft',
restockDate: '2025-10-05',
operationalStatus: 'Ready for Testing',
},
{
id: 679083,
itemName: 'Solar Panels',
itemNo: 'BW-09',
leadEngineer: 'Dave Bowman',
cost: 75000,
inStock: true,
category: 'Energy',
itemQuality: 95,
origin: '🇺🇸 USA',
quantity: 10,
valueStock: 750000,
repairable: false,
supplierName: 'SolarStream',
restockDate: '2025-11-10',
operationalStatus: 'Operational',
},
{
id: 912663,
itemName: 'Comm Array',
itemNo: 'ZR-56',
leadEngineer: 'Louise Banks',
cost: 125000,
inStock: false,
category: 'Communication',
itemQuality: 0,
origin: '🇯🇵 Japan',
quantity: 0,
valueStock: 0,
repairable: true,
supplierName: 'CommTech',
restockDate: '2025-12-20',
operationalStatus: 'Decommissioned',
},
{
id: 315806,
itemName: 'Habitat Dome',
itemNo: 'UJ-23',
leadEngineer: 'Dr. Ryan Stone',
cost: 1000000,
inStock: true,
category: 'Shelter',
itemQuality: 93,
origin: '🇨🇦 Canada',
quantity: 3,
valueStock: 3000000,
repairable: false,
supplierName: 'DomeInnovate',
restockDate: '2026-01-25',
operationalStatus: 'Operational',
},
{
id: 954632,
itemName: 'Oxygen Unit',
itemNo: 'FK-87',
leadEngineer: 'Dr. Grace Augustine',
cost: 600000,
inStock: true,
category: 'Life Support',
itemQuality: 85,
origin: '🇺🇸 USA',
quantity: 15,
valueStock: 9000000,
repairable: true,
supplierName: 'OxyGenius',
restockDate: '2026-03-02',
operationalStatus: 'Awaiting Parts',
},
{
id: 734944,
itemName: 'Processing Rig',
itemNo: 'LK-13',
leadEngineer: 'Jake Sully',
cost: 350000,
inStock: true,
category: 'Mining',
itemQuality: 81,
origin: '🇦🇺 Australia',
quantity: 25,
valueStock: 8750000,
repairable: true,
supplierName: 'RigTech',
restockDate: '2026-04-15',
operationalStatus: 'Ready for Testing',
},
{
id: 834662,
itemName: 'Navigation Module',
itemNo: 'XP-24',
leadEngineer: 'Dr. Ellie Arroway',
cost: 450000,
inStock: true,
category: 'Navigation',
itemQuality: 89,
origin: '🇫🇷 France',
quantity: 8,
valueStock: 3600000,
repairable: false,
supplierName: 'NavSolutions',
restockDate: '2026-05-30',
operationalStatus: 'In Maintenance',
},
{
id: 714329,
itemName: 'Surveyor Arm',
itemNo: 'QA-86',
leadEngineer: 'Mark Watney',
cost: 100000,
inStock: true,
category: 'Exploration',
itemQuality: 78,
origin: '🇺🇸 USA',
quantity: 40,
valueStock: 4000000,
repairable: true,
supplierName: 'ExploreTech',
restockDate: '2026-07-12',
operationalStatus: 'Decommissioned',
}
];
const data = inputData.map((el) => ({
...el,
// eslint-disable-next-line no-mixed-operators
color: `#${
// eslint-disable-next-line no-mixed-operators
Math.round(0x1000000 + 0xffffff * Math.random())
.toString(16)
.slice(1)
.toUpperCase()
}`,
}));
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1')!;
type ColorPickerEditor = { input: HTMLInputElement; pickr: ReturnType<typeof Pickr.create>; preventCloseElement: HTMLElement };
const cellDefinition: Pick<CellProperties, 'renderer' | 'validator' | 'editor'> = {
renderer: rendererFactory(({ td, value }) => {
td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
}),
validator: (value, callback) => {
callback(value.length === 7 && value[0] == '#'); // validate color format
},
editor: editorFactory<ColorPickerEditor>({
init(editor) {
editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
editor.input.setAttribute('aria-label', 'Open color picker');
editor.input.classList.add('color-picker-editor');
},
afterInit(editor) {
const button = editor.hot.rootDocument.createElement('button');
button.textContent = 'Open color picker';
button.classList.add('color-picker-button');
editor.input.after(button);
editor.pickr = Pickr.create({
el: button,
theme: 'nano',
default: editor.input.value || '#000000',
autoReposition: false,
padding: 0,
components: {
preview: true,
hue: true,
}
});
// Collapse the Pickr trigger button so it doesn't add vertical space
// between the cell editor and the popup.
editor.pickr._root.root.style.height = '0';
editor.pickr._root.root.style.overflow = 'hidden';
editor.preventCloseElement = editor.pickr._root.app;
editor.pickr.on('change', (color: { toHEXA: () => { toString: () => string } } | null) => {
if (color) {
const hex = color.toHEXA().toString();
editor.input.value = hex;
}
});
editor.pickr.on('hide', () => {
if (Date.now() - editor._openedAt < 400) {
editor.pickr.show();
return;
}
editor.finishEditing();
});
},
afterOpen(editor) {
editor._openedAt = Date.now();
editor.pickr.setColor(editor.input.value || '#000000');
editor.pickr.show();
// Pickr positions its popup relative to the trigger button with an
// internal offset. Override the top to sit flush below the cell.
requestAnimationFrame(() => {
requestAnimationFrame(() => {
const cellRect = editor.TD.getBoundingClientRect();
editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
});
});
},
afterClose(editor) {
editor.pickr._root.app.classList.remove('visible');
editor.pickr.hide();
},
getValue(editor) {
return editor.input.value;
},
setValue(editor, value) {
editor.input.value = value;
},
shortcuts: [
{
keys: [['Tab']],
callback: (editor) => {
editor.pickr.hide();
},
},
],
}),
};
// Define configuration options for the Handsontable
const hotOptions: Handsontable.GridSettings = {
data,
colHeaders: ['ID', 'Item Name', 'Item Color', 'Item No.', 'Cost', 'Value in Stock'],
autoRowSize: true,
rowHeaders: true,
height: 'auto',
width: '100%',
columns: [
{
data: 'id',
type: 'numeric',
width: 80,
headerClassName: 'htLeft'
},
{
data: 'itemName',
type: 'text',
width: 200,
headerClassName: 'htLeft'
},
{
data: 'color',
headerClassName: 'htLeft',
...cellDefinition,
},
{
data: 'itemNo',
type: 'text',
width: 100,
headerClassName: 'htLeft',
},
{
data: 'cost',
type: 'numeric',
width: 70,
headerClassName: 'htLeft',
},
{
data: 'valueStock',
type: 'numeric',
width: 130,
headerClassName: 'htRight',
},
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
CSS
.color-picker-cell {
display: flex;
align-items: center;
justify-content: center;
}
.color-picker-swatch {
width: 18px;
height: 18px;
border-radius: 50%;
flex-shrink: 0;
border: 1px solid rgba(0, 0, 0, 0.15);
}
.color-picker-editor {
width: 100%;
height: 100%;
border: none;
outline: none;
box-sizing: border-box !important;
cursor: pointer;
-webkit-appearance: none;
appearance: none;
}
.pickr {
position: absolute;
top: 0;
left: 0;
opacity: 0;
pointer-events: none;
}
html[data-theme="dark"] .pcr-app {
background-color: #1a1a1a;
}

Overview

This guide shows how to create a custom color picker cell using the Pickr library. Users can click a cell to open a color picker, select a color, and see it rendered with a colored background.

Difficulty: Beginner Time: ~15 minutes Libraries: @simonwep/pickr

What You’ll Build

A cell that:

  • Displays a colored circle swatch in the cell
  • Opens a color picker when edited via an “Open color picker” button
  • Shows a styled editor input with Handsontable’s native blue border
  • Validates hex color format
  • Updates the value as you pick a color; closing the picker saves and finishes editing
  • Closes the picker on Tab or Escape

Prerequisites

Terminal window
npm install @simonwep/pickr
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    import Pickr from '@simonwep/pickr';
    import '@simonwep/pickr/dist/themes/nano.min.css';
    registerAllModules();

    Why this matters:

    • editorFactory and rendererFactory are Handsontable helpers for creating custom editors and renderers
    • Pickr is created per-editor in the afterInit hook and attached to a button
    • Import Pickr theme CSS (e.g. nano.min.css) for the color picker UI styling
  2. Add CSS Styling

    Create a separate CSS file for the cell and editor styles. This uses Handsontable CSS custom properties (tokens) to match the native editor appearance.

    .color-picker-cell {
    display: flex;
    align-items: center;
    justify-content: center;
    }
    .color-picker-swatch {
    width: 18px;
    height: 18px;
    border-radius: 50%;
    flex-shrink: 0;
    border: 1px solid rgba(0, 0, 0, 0.15);
    }
    .color-picker-editor {
    width: 100%;
    height: 100%;
    border: none;
    outline: none;
    box-sizing: border-box !important;
    cursor: pointer;
    -webkit-appearance: none;
    appearance: none;
    }
    .pickr {
    position: absolute;
    top: 0;
    left: 0;
    opacity: 0;
    pointer-events: none;
    }

    What’s happening:

    • .color-picker-cell centers the circle swatch inside the cell
    • .color-picker-swatch renders a small circle with border-radius: 50%
    • .color-picker-editor removes default input borders and appearance so the editor can be styled as needed
  3. Create the Renderer

    The renderer controls how the cell looks when not being edited. The renderer displays a colored circle swatch.

    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
    })

    What’s happening:

    • td is the table cell DOM element
    • value is the cell’s current value (e.g., “#ff0000”)
    • The renderer displays a circle swatch with the color as its background
    • The swatch is centered inside the cell via CSS flexbox
  4. Create the Validator

    The validator ensures only valid hex colors are saved.

    validator: (value, callback) => {
    callback(value.length === 7 && value[0] == '#');
    }

    What’s happening:

    • Check if value is exactly 7 characters
    • Check if it starts with ’#’
    • Call callback(true) for valid, callback(false) for invalid

    Improvements for production:

    • Use regex: /^#[0-9A-Fa-f]{6}$/
    • Support short format: #fff
    • Support RGB/RGBA values
  5. Editor - Initialize (init)

    Create the input element that will hold the hex value, and apply the editor CSS class. A separate button for opening the picker is added in afterInit.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.setAttribute('aria-label', 'Open color picker');
    editor.input.classList.add('color-picker-editor');
    }

    What’s happening:

    1. Create an input element using editor.hot.rootDocument.createElement()
    2. Set an aria-label for accessibility
    3. Add the color-picker-editor CSS class for the blue border styling
    4. The editorFactory helper will handle container creation and DOM insertion

    Key points:

    • Use editor.hot.rootDocument.createElement() (not document.createElement()) for iframe/shadow DOM compatibility
    • The input stores the current hex value; a button added in afterInit will open the Pickr popup
    • The CSS class styles the editor (no border, full size) so the picker button is the main control
  6. Editor - After Init Hook (afterInit)

    Create a button, attach Pickr to it, and set up the change and hide event handlers. Setting preventCloseElement keeps the editor open when the user clicks inside the Pickr popup.

    afterInit(editor) {
    const button = editor.hot.rootDocument.createElement('button');
    button.textContent = 'Open color picker';
    button.classList.add('color-picker-button');
    editor.input.after(button);
    editor.pickr = Pickr.create({
    el: button,
    theme: 'nano',
    default: editor.input.value || '#000000',
    autoReposition: false,
    padding: 0,
    components: {
    preview: true,
    hue: true,
    }
    });
    // Collapse the Pickr trigger button so it doesn't add vertical space
    // between the cell editor and the popup.
    editor.pickr._root.root.style.height = '0';
    editor.pickr._root.root.style.overflow = 'hidden';
    editor.preventCloseElement = editor.pickr._root.app;
    editor.pickr.on('change', (color) => {
    if (color) {
    const hex = color.toHEXA().toString();
    editor.input.value = hex;
    }
    });
    editor.pickr.on('hide', () => {
    if (Date.now() - editor._openedAt < 400) {
    editor.pickr.show();
    return;
    }
    editor.finishEditing();
    });
    }

    What’s happening:

    1. Create a button and insert it after the input so users can open the picker
    2. Create a Pickr instance with theme nano and preview + hue components
    3. Set editor.preventCloseElement to the Pickr root so clicking inside the popup doesn’t close the editor
    4. On change, update the input value from the selected color (using color.toHEXA().toString())
    5. On hide, call editor.finishEditing() so closing the picker saves the value and closes the editor

    Why afterInit instead of init?

    • afterInit runs after the input is added to the DOM
    • Pickr needs the button to be in the DOM to attach properly
  7. Editor - After Open Hook (afterOpen)

    Set the current color and show the Pickr picker.

    afterOpen(editor) {
    editor._openedAt = Date.now();
    editor.pickr.setColor(editor.input.value || '#000000');
    editor.pickr.show();
    // Pickr positions its popup relative to the trigger button with an
    // internal offset. Use double-rAF to ensure Pickr's own positioning
    // is complete before overriding the top to sit flush below the cell.
    requestAnimationFrame(() => {
    requestAnimationFrame(() => {
    const cellRect = editor.TD.getBoundingClientRect();
    editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
    });
    });
    }

    What’s happening:

    • Sets the picker to the cell’s current color
    • Calls show() to open the Pickr popup

    Why afterOpen instead of open?

    • afterOpen runs after positioning is complete
    • The editorFactory helper handles positioning in open
  8. Editor - After Close Hook (afterClose)

    Ensure the Pickr popup is hidden when the editor closes.

    afterClose(editor) {
    editor.pickr._root.app.classList.remove('visible');
    editor.pickr.hide();
    }

    What’s happening:

    • Called when the editor is closed (by Tab, Escape, clicking outside, etc.)
    • Hides the Pickr picker via editor.pickr.hide()
    • Without this, the picker popup could remain visible after the editor closes
  9. Editor - Get Value / Set Value

    Standard value management hooks.

    getValue(editor) {
    return editor.input.value;
    }
    setValue(editor, value) {
    editor.input.value = value;
    }

    What’s happening:

    • getValue returns the input’s current value (hex color code) when Handsontable saves the cell
    • setValue initializes the editor with the cell’s current color value
    • On Pickr’s change event, editor.input.value is set from the selected color; when the user closes the picker, hide fires and editor.finishEditing() is called
  10. Editor - Keyboard Shortcuts

    Add a Tab shortcut to hide the picker (which triggers the hide event and then finishEditing()).

    shortcuts: [
    {
    keys: [['Tab']],
    callback: (editor) => {
    editor.pickr.hide();
    },
    },
    ]

    What’s happening:

    • Pressing Tab hides the Pickr popup, which fires the hide event and calls editor.finishEditing()
    • Uses the editorFactory shortcuts API to register key bindings
    • afterClose also calls editor.pickr.hide() when the editor closes by other means
  11. Complete Cell Definition

    Put it all together. The editor uses a hidden input for the value and a button that opens the Pickr popup; color is updated on change and editing finishes when the picker is closed (hide).

    type ColorPickerEditor = {
    input: HTMLInputElement;
    pickr: ReturnType<typeof Pickr.create>;
    preventCloseElement: HTMLElement;
    };
    const cellDefinition = {
    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
    }),
    validator: (value, callback) => {
    callback(value.length === 7 && value[0] == '#');
    },
    editor: editorFactory<ColorPickerEditor>({
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.setAttribute('aria-label', 'Open color picker');
    editor.input.classList.add('color-picker-editor');
    },
    afterInit(editor) {
    const button = editor.hot.rootDocument.createElement('button');
    button.textContent = 'Open color picker';
    button.classList.add('color-picker-button');
    editor.input.after(button);
    editor.pickr = Pickr.create({
    el: button,
    theme: 'nano',
    default: editor.input.value || '#000000',
    autoReposition: false,
    padding: 0,
    components: { preview: true, hue: true },
    });
    // Collapse the Pickr trigger button so it doesn't add vertical space
    // between the cell editor and the popup.
    editor.pickr._root.root.style.height = '0';
    editor.pickr._root.root.style.overflow = 'hidden';
    editor.preventCloseElement = editor.pickr._root.app;
    editor.pickr.on('change', (color) => {
    if (color) editor.input.value = color.toHEXA().toString();
    });
    editor.pickr.on('hide', () => {
    if (Date.now() - editor._openedAt < 400) {
    editor.pickr.show();
    return;
    }
    editor.finishEditing();
    });
    },
    afterOpen(editor) {
    editor._openedAt = Date.now();
    editor.pickr.setColor(editor.input.value || '#000000');
    editor.pickr.show();
    // Pickr positions its popup relative to the trigger button with an
    // internal offset. Override the top to sit flush below the cell.
    requestAnimationFrame(() => {
    requestAnimationFrame(() => {
    const cellRect = editor.TD.getBoundingClientRect();
    editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
    });
    });
    },
    afterClose(editor) {
    editor.pickr._root.app.classList.remove('visible');
    editor.pickr.hide();
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    },
    shortcuts: [
    {
    keys: [['Tab']],
    callback: (editor) => editor.pickr.hide(),
    },
    ],
    }),
    };

    What’s happening:

    • renderer: Displays a colored circle swatch centered in the cell
    • validator: Ensures hex color format (# followed by 6 characters)
    • editor: Uses editorFactory helper with:
      • init: Creates styled input element and aria-label
      • afterInit: Creates button, Pickr on the button (nano theme), preventCloseElement, and change / hide handlers
      • afterOpen: Sets current color and shows the picker
      • afterClose: Hides the Pickr popup when editor closes
      • shortcuts: Tab key hides the picker (which triggers hide and then finishEditing)
      • getValue / setValue: Standard value management via the input

    Note: The editorFactory helper handles container creation, positioning, and lifecycle management automatically.

  12. Use in Handsontable

    const container = document.querySelector('#example1')!;
    const hotOptions: Handsontable.GridSettings = {
    data: [
    { id: 1, itemName: 'Lunar Core', color: '#FF5733', itemNo: 'XJ-12', cost: 350000, valueStock: 700000 },
    { id: 2, itemName: 'Zero Thrusters', color: '#33FF57', itemNo: 'QL-54', cost: 450000, valueStock: 0 },
    { id: 3, itemName: 'EVA Suits', color: '#3357FF', itemNo: 'PM-67', cost: 150000, valueStock: 7500000 },
    ],
    colHeaders: ['ID', 'Item Name', 'Item Color', 'Item No.', 'Cost', 'Value in Stock'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    columns: [
    { data: 'id', type: 'numeric', width: 80, headerClassName: 'htLeft' },
    { data: 'itemName', type: 'text', width: 200, headerClassName: 'htLeft' },
    { data: 'color', headerClassName: 'htLeft', ...cellDefinition },
    { data: 'itemNo', type: 'text', width: 100, headerClassName: 'htLeft' },
    { data: 'cost', type: 'numeric', width: 70, headerClassName: 'htLeft' },
    { data: 'valueStock', type: 'numeric', width: 130, headerClassName: 'htRight' },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • ...cellDefinition - Spreads renderer, validator, and editor into the color column config
    • The validator ensures only valid hex colors are saved
    • The live example uses more rows and random hex colors; you can use any data that includes a color field

How It Works - Complete Flow

  1. Initial Render: Cell displays a colored circle swatch
  2. User Double-Clicks or F2: Editor opens with a styled input and an “Open color picker” button
  3. Color Picker Opens: afterOpen sets the current color and calls pickr.show()
  4. User Selects Color: Pickr updates the preview; the change event updates editor.input.value with the hex from color.toHEXA().toString()
  5. User Closes Picker (or presses Tab): The hide event fires (or Tab triggers pickr.hide()), then editor.finishEditing() is called
  6. Validation: Validator checks hex format (# followed by 6 characters)
  7. Save: If valid, value is saved to cell; if invalid, editor may stay open
  8. Editor Closes: afterClose calls editor.pickr.hide(), cell renderer shows updated swatch

Enhancements

  1. Add Color Swatches

    Provide preset colors:

    editor.pickr = Pickr.create({
    el: button,
    // ...other options
    swatches: [
    '#ff0000',
    '#00ff00',
    '#0000ff',
    '#ffff00',
    '#ff00ff',
    '#00ffff'
    ],
    });
  2. Support Alpha Channel

    Allow transparency by setting lockOpacity: false and enabling the opacity component:

    Pickr.create({
    // ...
    lockOpacity: false,
    components: {
    preview: true,
    opacity: true,
    hue: true,
    // ...
    },
    });
    // Update validator for rgba
    validator: (value, callback) => {
    const rgbaRegex = /^rgba?\(\d+,\s*\d+,\s*\d+(?:,\s*[\d.]+)?\)$/;
    callback(rgbaRegex.test(value));
    }
  3. Use a Different Theme

    This recipe uses the nano theme. Pickr also offers classic and monolith. To switch, change the CSS import and the theme option:

    import '@simonwep/pickr/dist/themes/classic.min.css';
    // In Pickr.create():
    theme: 'classic',

What you learned

You integrated the Pickr color picker library as a Handsontable cell editor. You used editorFactory to manage the editor lifecycle, rendererFactory to display a color swatch, and Handsontable’s CSS tokens to style the editor consistently with the rest of the grid.

Next steps

Skip to content

Color picker

This tutorial shows you how to integrate the Pickr color picker library as a custom Handsontable cell editor, with a swatch renderer and hex validation.

TypeScript
/* file: app.component.ts */
import { Component, ChangeDetectionStrategy, ElementRef, ViewChild } from '@angular/core';
import {
GridSettings,
HotCellEditorAdvancedComponent,
HotCellRendererAdvancedComponent,
HotTableModule
} from '@handsontable/angular-wrapper';
import Pickr from '@simonwep/pickr';
import '@simonwep/pickr/dist/themes/nano.min.css';
/* start:skip-in-preview */
const inputData = [
{ id: 640329, itemName: 'Lunar Core', itemNo: 'XJ-12', cost: 350000, valueStock: 700000 },
{ id: 863104, itemName: 'Zero Thrusters', itemNo: 'QL-54', cost: 450000, valueStock: 0 },
{ id: 395603, itemName: 'EVA Suits', itemNo: 'PM-67', cost: 150000, valueStock: 7500000 },
{ id: 679083, itemName: 'Solar Panels', itemNo: 'BW-09', cost: 75000, valueStock: 750000 },
{ id: 912663, itemName: 'Comm Array', itemNo: 'ZR-56', cost: 125000, valueStock: 0 },
{ id: 315806, itemName: 'Habitat Dome', itemNo: 'UJ-23', cost: 1000000, valueStock: 3000000 },
{ id: 954632, itemName: 'Oxygen Unit', itemNo: 'FK-87', cost: 600000, valueStock: 9000000 },
{ id: 734944, itemName: 'Processing Rig', itemNo: 'LK-13', cost: 350000, valueStock: 8750000 },
];
/* end:skip-in-preview */
const colorValidator = (value: string): boolean => /^#[0-9A-Fa-f]{6}$/.test(value);
@Component({
standalone: true,
selector: 'example1-color-renderer',
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div class="color-picker-cell">
<span class="color-picker-swatch" [style.background]="value"></span>
</div>`,
styles: `
:host { height: 100%; width: 100%; }
.color-picker-cell { display: flex; align-items: center; justify-content: center; }
.color-picker-swatch { width: 18px; height: 18px; border-radius: 50%; flex-shrink: 0; border: 1px solid rgba(0,0,0,0.15); }
`,
})
export class ColorRendererComponent extends HotCellRendererAdvancedComponent<string> {}
@Component({
standalone: true,
selector: 'example1-color-picker-editor',
template: `
<div #editorContainer style="width:100%;height:100%;position:relative;">
<input #colorInput class="color-picker-editor" type="text" readonly />
</div>
`,
styles: `
:host { width: 100%; height: 100%; }
.color-picker-editor { width: 100%; height: 100%; border: none; outline: none; box-sizing: border-box !important; cursor: pointer; }
`,
})
export class ColorPickerEditorComponent extends HotCellEditorAdvancedComponent<string> {
@ViewChild('colorInput', { static: true }) colorInput!: ElementRef<HTMLInputElement>;
@ViewChild('editorContainer', { static: true }) editorContainer!: ElementRef<HTMLElement>;
private pickrInstance: Pickr | null = null;
private pickrButton: HTMLButtonElement | null = null;
private openedAt = 0;
override afterOpen(): void {
this.openedAt = Date.now();
this.colorInput.nativeElement.value = this.value || '#000000';
this.pickrButton = document.createElement('button');
this.pickrButton.textContent = 'Open color picker';
this.pickrButton.style.cssText = 'position:absolute;opacity:0;pointer-events:none;';
this.editorContainer.nativeElement.appendChild(this.pickrButton);
const button = this.pickrButton;
this.pickrInstance = Pickr.create({
el: button,
theme: 'nano',
default: this.value || '#000000',
autoReposition: false,
padding: 0,
components: { preview: true, hue: true },
});
(this.pickrInstance as any)._root.root.style.height = '0';
(this.pickrInstance as any)._root.root.style.overflow = 'hidden';
this.pickrInstance.on('change', (color: { toHEXA: () => { toString: () => string } } | null) => {
if (color) {
const hex = color.toHEXA().toString();
this.colorInput.nativeElement.value = hex;
this.setValue(hex);
}
});
this.pickrInstance.on('hide', () => {
if (Date.now() - this.openedAt < 400) {
this.pickrInstance?.show();
return;
}
this.finishEdit.emit();
});
this.pickrInstance.show();
requestAnimationFrame(() => {
requestAnimationFrame(() => {
const cellRect = this.editorContainer.nativeElement.getBoundingClientRect();
if (cellRect && this.pickrInstance) {
(this.pickrInstance as any)._root.app.style.top = `${cellRect.bottom}px`;
}
});
});
}
override afterClose(): void {
(this.pickrInstance as any)?._root.app.classList.remove('visible');
this.pickrInstance?.hide();
this.pickrInstance?.destroy();
this.pickrInstance = null;
this.pickrButton?.remove();
this.pickrButton = null;
}
override onFocus(): void {
this.colorInput.nativeElement.focus();
}
}
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'example1-color-picker',
template: `<div><hot-table [data]="data" [settings]="gridSettings"></hot-table></div>`,
})
export class AppComponent {
readonly data = inputData.map((el) => ({
...el,
color: `#${Math.round(0x1000000 + 0xffffff * Math.random()).toString(16).slice(1).toUpperCase()}`,
}));
readonly gridSettings: GridSettings = {
autoRowSize: true,
rowHeaders: true,
autoWrapRow: true,
height: 'auto',
width: '100%',
colHeaders: ['ID', 'Item Name', 'Item Color', 'Item No.', 'Cost', 'Value in Stock'],
columns: [
{ data: 'id', type: 'numeric', width: 80, headerClassName: 'htLeft' },
{ data: 'itemName', type: 'text', width: 200, headerClassName: 'htLeft' },
{
data: 'color',
headerClassName: 'htLeft',
editor: ColorPickerEditorComponent,
renderer: ColorRendererComponent,
validator: colorValidator,
} as any,
{ data: 'itemNo', type: 'text', width: 100, headerClassName: 'htLeft' },
{ data: 'cost', type: 'numeric', width: 70, headerClassName: 'htLeft' },
{ data: 'valueStock', type: 'numeric', width: 130, headerClassName: 'htRight' },
],
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-color-picker></example1-color-picker>
</div>

Overview

This guide shows how to create a custom color picker cell using the Pickr library. Users can click a cell to open a color picker, select a color, and see it rendered with a colored background.

Difficulty: Beginner Time: ~15 minutes Libraries: @simonwep/pickr

What You’ll Build

A cell that:

  • Displays a colored circle swatch in the cell
  • Opens a color picker when edited via an “Open color picker” button
  • Shows a styled editor input with Handsontable’s native blue border
  • Validates hex color format
  • Updates the value as you pick a color; closing the picker saves and finishes editing
  • Closes the picker on Tab or Escape

Prerequisites

Terminal window
npm install @simonwep/pickr
  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { editorFactory } from 'handsontable/editors';
    import { rendererFactory } from 'handsontable/renderers';
    import Pickr from '@simonwep/pickr';
    import '@simonwep/pickr/dist/themes/nano.min.css';
    registerAllModules();

    Why this matters:

    • editorFactory and rendererFactory are Handsontable helpers for creating custom editors and renderers
    • Pickr is created per-editor in the afterInit hook and attached to a button
    • Import Pickr theme CSS (e.g. nano.min.css) for the color picker UI styling
  2. Add CSS Styling

    Create a separate CSS file for the cell and editor styles. This uses Handsontable CSS custom properties (tokens) to match the native editor appearance.

    .color-picker-cell {
    display: flex;
    align-items: center;
    justify-content: center;
    }
    .color-picker-swatch {
    width: 18px;
    height: 18px;
    border-radius: 50%;
    flex-shrink: 0;
    border: 1px solid rgba(0, 0, 0, 0.15);
    }
    .color-picker-editor {
    width: 100%;
    height: 100%;
    border: none;
    outline: none;
    box-sizing: border-box !important;
    cursor: pointer;
    -webkit-appearance: none;
    appearance: none;
    }
    .pickr {
    position: absolute;
    top: 0;
    left: 0;
    opacity: 0;
    pointer-events: none;
    }

    What’s happening:

    • .color-picker-cell centers the circle swatch inside the cell
    • .color-picker-swatch renders a small circle with border-radius: 50%
    • .color-picker-editor removes default input borders and appearance so the editor can be styled as needed
  3. Create the Renderer

    The renderer controls how the cell looks when not being edited. The renderer displays a colored circle swatch.

    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
    })

    What’s happening:

    • td is the table cell DOM element
    • value is the cell’s current value (e.g., “#ff0000”)
    • The renderer displays a circle swatch with the color as its background
    • The swatch is centered inside the cell via CSS flexbox
  4. Create the Validator

    The validator ensures only valid hex colors are saved.

    validator: (value, callback) => {
    callback(value.length === 7 && value[0] == '#');
    }

    What’s happening:

    • Check if value is exactly 7 characters
    • Check if it starts with ’#’
    • Call callback(true) for valid, callback(false) for invalid

    Improvements for production:

    • Use regex: /^#[0-9A-Fa-f]{6}$/
    • Support short format: #fff
    • Support RGB/RGBA values
  5. Editor - Initialize (init)

    Create the input element that will hold the hex value, and apply the editor CSS class. A separate button for opening the picker is added in afterInit.

    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.setAttribute('aria-label', 'Open color picker');
    editor.input.classList.add('color-picker-editor');
    }

    What’s happening:

    1. Create an input element using editor.hot.rootDocument.createElement()
    2. Set an aria-label for accessibility
    3. Add the color-picker-editor CSS class for the blue border styling
    4. The editorFactory helper will handle container creation and DOM insertion

    Key points:

    • Use editor.hot.rootDocument.createElement() (not document.createElement()) for iframe/shadow DOM compatibility
    • The input stores the current hex value; a button added in afterInit will open the Pickr popup
    • The CSS class styles the editor (no border, full size) so the picker button is the main control
  6. Editor - After Init Hook (afterInit)

    Create a button, attach Pickr to it, and set up the change and hide event handlers. Setting preventCloseElement keeps the editor open when the user clicks inside the Pickr popup.

    afterInit(editor) {
    const button = editor.hot.rootDocument.createElement('button');
    button.textContent = 'Open color picker';
    button.classList.add('color-picker-button');
    editor.input.after(button);
    editor.pickr = Pickr.create({
    el: button,
    theme: 'nano',
    default: editor.input.value || '#000000',
    autoReposition: false,
    padding: 0,
    components: {
    preview: true,
    hue: true,
    }
    });
    // Collapse the Pickr trigger button so it doesn't add vertical space
    // between the cell editor and the popup.
    editor.pickr._root.root.style.height = '0';
    editor.pickr._root.root.style.overflow = 'hidden';
    editor.preventCloseElement = editor.pickr._root.app;
    editor.pickr.on('change', (color) => {
    if (color) {
    const hex = color.toHEXA().toString();
    editor.input.value = hex;
    }
    });
    editor.pickr.on('hide', () => {
    if (Date.now() - editor._openedAt < 400) {
    editor.pickr.show();
    return;
    }
    editor.finishEditing();
    });
    }

    What’s happening:

    1. Create a button and insert it after the input so users can open the picker
    2. Create a Pickr instance with theme nano and preview + hue components
    3. Set editor.preventCloseElement to the Pickr root so clicking inside the popup doesn’t close the editor
    4. On change, update the input value from the selected color (using color.toHEXA().toString())
    5. On hide, call editor.finishEditing() so closing the picker saves the value and closes the editor

    Why afterInit instead of init?

    • afterInit runs after the input is added to the DOM
    • Pickr needs the button to be in the DOM to attach properly
  7. Editor - After Open Hook (afterOpen)

    Set the current color and show the Pickr picker.

    afterOpen(editor) {
    editor._openedAt = Date.now();
    editor.pickr.setColor(editor.input.value || '#000000');
    editor.pickr.show();
    // Pickr positions its popup relative to the trigger button with an
    // internal offset. Use double-rAF to ensure Pickr's own positioning
    // is complete before overriding the top to sit flush below the cell.
    requestAnimationFrame(() => {
    requestAnimationFrame(() => {
    const cellRect = editor.TD.getBoundingClientRect();
    editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
    });
    });
    }

    What’s happening:

    • Sets the picker to the cell’s current color
    • Calls show() to open the Pickr popup

    Why afterOpen instead of open?

    • afterOpen runs after positioning is complete
    • The editorFactory helper handles positioning in open
  8. Editor - After Close Hook (afterClose)

    Ensure the Pickr popup is hidden when the editor closes.

    afterClose(editor) {
    editor.pickr._root.app.classList.remove('visible');
    editor.pickr.hide();
    }

    What’s happening:

    • Called when the editor is closed (by Tab, Escape, clicking outside, etc.)
    • Hides the Pickr picker via editor.pickr.hide()
    • Without this, the picker popup could remain visible after the editor closes
  9. Editor - Get Value / Set Value

    Standard value management hooks.

    getValue(editor) {
    return editor.input.value;
    }
    setValue(editor, value) {
    editor.input.value = value;
    }

    What’s happening:

    • getValue returns the input’s current value (hex color code) when Handsontable saves the cell
    • setValue initializes the editor with the cell’s current color value
    • On Pickr’s change event, editor.input.value is set from the selected color; when the user closes the picker, hide fires and editor.finishEditing() is called
  10. Editor - Keyboard Shortcuts

    Add a Tab shortcut to hide the picker (which triggers the hide event and then finishEditing()).

    shortcuts: [
    {
    keys: [['Tab']],
    callback: (editor) => {
    editor.pickr.hide();
    },
    },
    ]

    What’s happening:

    • Pressing Tab hides the Pickr popup, which fires the hide event and calls editor.finishEditing()
    • Uses the editorFactory shortcuts API to register key bindings
    • afterClose also calls editor.pickr.hide() when the editor closes by other means
  11. Complete Cell Definition

    Put it all together. The editor uses a hidden input for the value and a button that opens the Pickr popup; color is updated on change and editing finishes when the picker is closed (hide).

    type ColorPickerEditor = {
    input: HTMLInputElement;
    pickr: ReturnType<typeof Pickr.create>;
    preventCloseElement: HTMLElement;
    };
    const cellDefinition = {
    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `<span class="color-picker-cell"><span class="color-picker-swatch" style="background:${value}"></span></span>`;
    }),
    validator: (value, callback) => {
    callback(value.length === 7 && value[0] == '#');
    },
    editor: editorFactory<ColorPickerEditor>({
    init(editor) {
    editor.input = editor.hot.rootDocument.createElement('INPUT') as HTMLInputElement;
    editor.input.setAttribute('aria-label', 'Open color picker');
    editor.input.classList.add('color-picker-editor');
    },
    afterInit(editor) {
    const button = editor.hot.rootDocument.createElement('button');
    button.textContent = 'Open color picker';
    button.classList.add('color-picker-button');
    editor.input.after(button);
    editor.pickr = Pickr.create({
    el: button,
    theme: 'nano',
    default: editor.input.value || '#000000',
    autoReposition: false,
    padding: 0,
    components: { preview: true, hue: true },
    });
    // Collapse the Pickr trigger button so it doesn't add vertical space
    // between the cell editor and the popup.
    editor.pickr._root.root.style.height = '0';
    editor.pickr._root.root.style.overflow = 'hidden';
    editor.preventCloseElement = editor.pickr._root.app;
    editor.pickr.on('change', (color) => {
    if (color) editor.input.value = color.toHEXA().toString();
    });
    editor.pickr.on('hide', () => {
    if (Date.now() - editor._openedAt < 400) {
    editor.pickr.show();
    return;
    }
    editor.finishEditing();
    });
    },
    afterOpen(editor) {
    editor._openedAt = Date.now();
    editor.pickr.setColor(editor.input.value || '#000000');
    editor.pickr.show();
    // Pickr positions its popup relative to the trigger button with an
    // internal offset. Override the top to sit flush below the cell.
    requestAnimationFrame(() => {
    requestAnimationFrame(() => {
    const cellRect = editor.TD.getBoundingClientRect();
    editor.pickr._root.app.style.top = `${cellRect.bottom}px`;
    });
    });
    },
    afterClose(editor) {
    editor.pickr._root.app.classList.remove('visible');
    editor.pickr.hide();
    },
    getValue(editor) {
    return editor.input.value;
    },
    setValue(editor, value) {
    editor.input.value = value;
    },
    shortcuts: [
    {
    keys: [['Tab']],
    callback: (editor) => editor.pickr.hide(),
    },
    ],
    }),
    };

    What’s happening:

    • renderer: Displays a colored circle swatch centered in the cell
    • validator: Ensures hex color format (# followed by 6 characters)
    • editor: Uses editorFactory helper with:
      • init: Creates styled input element and aria-label
      • afterInit: Creates button, Pickr on the button (nano theme), preventCloseElement, and change / hide handlers
      • afterOpen: Sets current color and shows the picker
      • afterClose: Hides the Pickr popup when editor closes
      • shortcuts: Tab key hides the picker (which triggers hide and then finishEditing)
      • getValue / setValue: Standard value management via the input

    Note: The editorFactory helper handles container creation, positioning, and lifecycle management automatically.

  12. Use in Handsontable

    const container = document.querySelector('#example1')!;
    const hotOptions: Handsontable.GridSettings = {
    data: [
    { id: 1, itemName: 'Lunar Core', color: '#FF5733', itemNo: 'XJ-12', cost: 350000, valueStock: 700000 },
    { id: 2, itemName: 'Zero Thrusters', color: '#33FF57', itemNo: 'QL-54', cost: 450000, valueStock: 0 },
    { id: 3, itemName: 'EVA Suits', color: '#3357FF', itemNo: 'PM-67', cost: 150000, valueStock: 7500000 },
    ],
    colHeaders: ['ID', 'Item Name', 'Item Color', 'Item No.', 'Cost', 'Value in Stock'],
    autoRowSize: true,
    rowHeaders: true,
    height: 'auto',
    width: '100%',
    columns: [
    { data: 'id', type: 'numeric', width: 80, headerClassName: 'htLeft' },
    { data: 'itemName', type: 'text', width: 200, headerClassName: 'htLeft' },
    { data: 'color', headerClassName: 'htLeft', ...cellDefinition },
    { data: 'itemNo', type: 'text', width: 100, headerClassName: 'htLeft' },
    { data: 'cost', type: 'numeric', width: 70, headerClassName: 'htLeft' },
    { data: 'valueStock', type: 'numeric', width: 130, headerClassName: 'htRight' },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • ...cellDefinition - Spreads renderer, validator, and editor into the color column config
    • The validator ensures only valid hex colors are saved
    • The live example uses more rows and random hex colors; you can use any data that includes a color field

How It Works - Complete Flow

  1. Initial Render: Cell displays a colored circle swatch
  2. User Double-Clicks or F2: Editor opens with a styled input and an “Open color picker” button
  3. Color Picker Opens: afterOpen sets the current color and calls pickr.show()
  4. User Selects Color: Pickr updates the preview; the change event updates editor.input.value with the hex from color.toHEXA().toString()
  5. User Closes Picker (or presses Tab): The hide event fires (or Tab triggers pickr.hide()), then editor.finishEditing() is called
  6. Validation: Validator checks hex format (# followed by 6 characters)
  7. Save: If valid, value is saved to cell; if invalid, editor may stay open
  8. Editor Closes: afterClose calls editor.pickr.hide(), cell renderer shows updated swatch

Enhancements

  1. Add Color Swatches

    Provide preset colors:

    editor.pickr = Pickr.create({
    el: button,
    // ...other options
    swatches: [
    '#ff0000',
    '#00ff00',
    '#0000ff',
    '#ffff00',
    '#ff00ff',
    '#00ffff'
    ],
    });
  2. Support Alpha Channel

    Allow transparency by setting lockOpacity: false and enabling the opacity component:

    Pickr.create({
    // ...
    lockOpacity: false,
    components: {
    preview: true,
    opacity: true,
    hue: true,
    // ...
    },
    });
    // Update validator for rgba
    validator: (value, callback) => {
    const rgbaRegex = /^rgba?\(\d+,\s*\d+,\s*\d+(?:,\s*[\d.]+)?\)$/;
    callback(rgbaRegex.test(value));
    }
  3. Use a Different Theme

    This recipe uses the nano theme. Pickr also offers classic and monolith. To switch, change the CSS import and the theme option:

    import '@simonwep/pickr/dist/themes/classic.min.css';
    // In Pickr.create():
    theme: 'classic',

What you learned

You integrated the Pickr color picker library as a Handsontable cell editor. You used editorFactory to manage the editor lifecycle, rendererFactory to display a color swatch, and Handsontable’s CSS tokens to style the editor consistently with the rest of the grid.

Next steps